// ------------------------------------------------------------------------------
// DPF.Android.OS Component
//
// Dadeh Pardazane Faragir ( DPF ) Co.
//
// Web: http://www.dpfaragir.com
//
// Developed By: Babak Yaghoobi
//
// Email #1: yaghoobi@dpfaragir.com
// Email #2: b_yaghobi@yahoo.com
//
// ------------------------------------------------------------------------------
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// ------------------------------------------------------------------------------
unit DPF.Android.OS;

interface

{$I DPF.ANDROID.Defs.inc}

uses
  System.SysUtils,
  System.Classes,
  System.Types,
  System.UITypes,

  System.TypInfo,
{$IFDEF ANDROID}
  Androidapi.JNI.OS,
  Androidapi.JNI.JavaTypes,
  Androidapi.Jni,
  Androidapi.JNIBridge,
  Androidapi.JNI.Embarcadero,
  Androidapi.JNI.GraphicsContentViewText,
  Androidapi.JNI.Util,
  Androidapi.Log,
  FMX.Helpers.Android,
  FMX.Platform.Android,
{$ELSE}
  DPF.ANDROID.DesignTime,
{$ENDIF}
{$IFDEF DELPHIXE5} FMX.Graphics, {$ENDIF}FMX.Types;

{$IFDEF ANDROID}

type

  JSystemClock = interface;

  // ----------------------------------------------------------------------------
  // JChronometer Class
  // ----------------------------------------------------------------------------
  JSystemClockClass = interface( JObjectClass )
    ['{6994993B-B74C-48E5-8C4C-85C35777B499}']

    function currentTimeMillis: int64; cdecl;
    function uptimeMillis: int64; cdecl;
    function currentThreadTimeMillis: int64; cdecl;
    function elapsedRealtime: int64; cdecl;
    function elapsedRealtimeNanos: int64; cdecl;
    function setCurrentTimeMillis( millis: int64 ): boolean; cdecl;
    procedure sleep( ms: int64 ); cdecl;
  end;

  [JavaSignature( 'android/OS/SystemClock' )]
  JSystemClock = interface( JObject )
    ['{9CF240C7-5960-4202-A3EF-00B1BE4B26E2}']

  end;

  TJSystemClock = class( TJavaGenericImport<JSystemClockClass, JSystemClock> )
  end;

{$ENDIF}

  // ------------------------------------------------------------------------------
implementation

// ------------------------------------------------------------------------------
end.
